import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

public class HorizontalBarMeter extends BarMeter {

    protected AffineTransform trans;

    public Dimension getMinimumSize(){
        return new Dimension(100, 50);
    }

    public void createBufferImage(){
        // Avbg̃TCY
        Dimension size = this.getSize();

        // ]邽߂ɁAƕւ
        height = size.width;
        width = size.height;

        // 90x]
        AffineTransform rotate
            = AffineTransform.getRotateInstance(Math.toRadians(90), 0.0, 0.0);
        // ړ
        trans = AffineTransform.getTranslateInstance(height, 0.0);
        // ]ƈړgݍ킹
        trans.concatenate(rotate);

        // C[W̐
        if(width != 0 && height != 0){
            image = this.createImage(width, height);
            graphics = image.getGraphics();
        }
    }

    public void paint(Graphics g){

        // _uobt@Op̃C[WȂ΁A
        // AOtBbNReLXgB
        if(image == null || resizeFlag){
            createBufferImage();
            resizeFlag = false;
        }

        // wiFœhԂ
        graphics.setColor(this.getBackground());
        graphics.fillRect(0, 0, width, height);

        // o[̕`
        drawBar(graphics, value);

        // Java2D ̃OtBbNReLXgɕϊ
        Graphics2D g2 = (Graphics2D)g;

        // C[Wobt@̕`
        g2.drawImage(image, trans, this);
    }
}
